RAT = function(
validities =  c(.8,.7,.6,.55), 
cuePattern = cbind(c(1,1,1,-1),c(-1,-1,-1,1))
){

########################
########################
########################
#### recode validities and patterns if val < .5

recodeVal = which(round(validities, 6) < .5)

if (length(recodeVal) > 0){

validities[recodeVal] = 1 - validities[recodeVal]
cuePattern[recodeVal,] = cuePattern[recodeVal,] * -1
}

########################
########################
########################

RatCueDiff = cuePattern[,1] - cuePattern[,2]

LAB = (log(validities/(1-validities)) * sign(RatCueDiff))
LAB = ifelse(is.na(LAB) == TRUE, 0, LAB)
LAB = sum(LAB)
LAB = ifelse(is.na(LAB) == TRUE, 0, LAB)

choiceRat = ifelse(round(LAB,6) > 0, 1 , 2)
choiceRat = ifelse(round(LAB,6) == 0, 1/2, choiceRat)
choiceRat = ifelse(round(choiceRat,6) == 2, 0, choiceRat)

timeRat = 
# EIPs to look up cues

(2 * NROW(validities)) + 
(2 * NROW(validities)) +
(2 * NROW(validities)) +
(2 * NROW(validities) - 2) + 
2

confRat = abs(LAB) 

RATpredTotal = c(choiceRat,timeRat,confRat)
names(RATpredTotal) = c("choice","time","confidence") 

return(RATpredTotal)
}

###

library(compiler)
RAT = cmpfun(RAT)
