TTB = function(
validities =  c(.8,.7,.6,.55), 
cuePattern = cbind(c(1,1,1,-1),c(-1,-1,-1,1))
){

########################
########################
########################
#### recode validities and patterns if val < .5

recodeVal = which(round(validities, 6) < .5)

if (length(recodeVal) > 0){

validities[recodeVal] = 1 - validities[recodeVal]
cuePattern[recodeVal,] = cuePattern[recodeVal,] * -1
}

########################
########################
########################

#### find most valid cues, if cues are equally valid pick one randomly

cuesOrderedByValidity = order(abs(validities), decreasing = TRUE)
uniqueCueVals = unique(sort(abs(validities[
round(validities,6) != .5]), decreasing=TRUE))

finalCueOrder = numeric()

for (i in 1 : length(uniqueCueVals)){

resampCueOrder = cuesOrderedByValidity[
(sort(abs(validities),decreasing=TRUE)) == uniqueCueVals[i]]

resampCueOrder = resampCueOrder[sample(length(resampCueOrder))]

finalCueOrder = c(finalCueOrder,resampCueOrder)
}

#### find position of the first discriminating cue

posDiscr = which(cuePattern[finalCueOrder,1] - 
cuePattern [finalCueOrder,2] != 0)[1]

timeTTB = ifelse(is.na(posDiscr) == TRUE,(length(validities)*3) + 1,
(posDiscr * 3) + 1)

posDiscr = finalCueOrder[posDiscr]

#### predictions based on the discriminating cue

choiceTTB = ifelse(length(posDiscr) == 0, 0.5 , 
which(cuePattern[posDiscr,] == max(cuePattern[posDiscr,])))

choiceTTB = ifelse(round(choiceTTB,6) == 2, 0, choiceTTB)

confTTB = ifelse(length(posDiscr) == 0, 0.5,
validities[posDiscr])

if (is.na(choiceTTB) == TRUE){

TTBpredTotal = c(.5,timeTTB,.5)

} else {

TTBpredTotal = c(choiceTTB, timeTTB, confTTB)
}

names(TTBpredTotal) = c("choice","time","confidence") 

return(TTBpredTotal)
}

###

library(compiler)
TTB = cmpfun(TTB)